<template>
  <el-dialog
    v-model="dialogModel"
    align-center
    custom-class="message-preview-dialog"
    @closed="onDialogClosed"
  >
    <div class="message-preview-header pb-2 mb-2">
      <h5 class="message-preview-title">{{ message?.Contents?.Title }}</h5>
      <div class="flex items-center justify-between">
        <span class="message-preview-date">{{ message?.DateDisplay }}</span>
        <MessagesMessageType :type="message?.TypeDisplay" />
      </div>
    </div>
    <el-scrollbar class="message-preview-content">
      <div class="message-content" v-html="message?.Contents?.Content"></div>
    </el-scrollbar>
    <template #footer>
      <div class="flex gap-2 w-full">
        <el-button
          class="message-action-button w-full"
          type="danger"
          @click="$emit('click:delete')"
          >{{ $t("delete") }}</el-button
        >
        <el-button
          class="message-action-button w-full !ml-0 ol-bg-light-2"
          @click="dialogModel = false"
          >{{ $t("Close") }}</el-button
        >
      </div>
    </template>
  </el-dialog>
</template>

<script setup lang="ts">
import { MemberMessage } from "~~/models/message";

const emit = defineEmits<{
  (e: "update:modelValue", value: boolean): void;
  (e: "click:delete"): void;
  (e: "update:message", value: MemberMessage | undefined): void;
}>();

const props = defineProps<{
  modelValue: boolean;
  message: MemberMessage;
}>();

const dialogModel = computed({
  get: () => props.modelValue,
  set: (value) => emit("update:modelValue", value),
});
const onDialogClosed = () => {
  emit("update:message", undefined);
};
</script>

<style lang="scss">
.message-preview-dialog {
  --el-dialog-border-radius: 8px;
  --el-dialog-margin-top: auto;
  margin-bottom: auto;
  overflow: hidden;
  width: 400px;

  [layout="modern"] &.el-dialog {
    --el-dialog-bg-color: var(--background5);
  }

  .message-content {
    opacity: 0.8;
    font-family: Roboto;
    font-size: 12px;
    font-weight: 400;
    line-height: 18px;
    letter-spacing: 0em;
    text-align: left;
    color: var(--text5);

    ol {
      list-style: auto; // set to unset becuae it is override by other file
      margin-left: 14px;
    }
  }

  .el-dialog__header {
    display: none;
  }

  .el-dialog__body {
    padding: 16px;
  }

  .el-dialog__body,
  .el-dialog__footer {
    background: var(--background5);
  }
  
  .el-dialog__footer {
    border-top: 1px solid var(--border);
    padding: 16px !important;
  }

  .message-preview-header {
    border-bottom: 1px solid var(--border);

    .message-preview-title {
      color: var(--text5);
      font-family: Roboto;
      font-size: 12px;
      font-weight: 700;
      line-height: 14px;
      letter-spacing: 0em;
      text-align: left;
      margin-bottom: 8px;
    }

    .message-preview-date {
      opacity: 0.6;
      color: var(--text5);
      font-family: Roboto;
      font-size: 12px;
      font-weight: 400;
      line-height: 14px;
      letter-spacing: 0em;
      text-align: left;
    }
  }
  .message-preview-content {
    height: 289px;
  }
}

[data-device="mobile"] .message-preview-dialog {
  --el-dialog-border-radius: 8px;
  --el-dialog-margin-top: auto;
  margin-bottom: auto;
  overflow: hidden;
  width: 96%;
}
</style>
